/***********************************************************************
 *              Berliner Uhr
 *            ================
 *            Uwe Berger; 2009
 * 
 * 
 * Version mit (nativ) X.
 * 
 * ---------
 * Have fun!
 * 
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

// Default-Werte
#define WINDOW_WIDTH	180
#define WINDOW_HEIGHT	WINDOW_WIDTH


int now_s, now_m, now_h;
time_t now;
struct tm *now_tm;

Display *mydpy;
Window mywin;
char win_title[] = {"Berlin Uhr"};

//**********************************************************************
static void setcolourvianame (Display *display, int screen, GC myGC, char *colourname) {
	/* genaue RGB  Komponenten der Farbe */
	XColor rgbcolour;
	/* am naheste liegende RGB-Farben der Hardware */
	XColor hwarecolour;
	int status;
	/* Colormap */
	Colormap  myColourmap;
	int myDepth;

	myDepth = DefaultDepth (display, screen);
	myColourmap = DefaultColormap (display, screen);
	screen = DefaultScreen (display);
	if (myDepth > 1) {
		status = XLookupColor (
					display, myColourmap,colourname,&rgbcolour,&hwarecolour );
		if (status != 0) {
			/* Farben für die Color map reservieren */
			status = XAllocColor ( display, myColourmap, &hwarecolour);
			if (status != 0) {
				/* Zeichenfarbe setzen */
				XSetForeground (display, myGC, hwarecolour.pixel );
			}
			else {
				printf ("Kann Farbzelle für %s nicht ermitteln\n", colourname);
				printf ("Verwende stattdessen Schwarz\n");
				XSetForeground(display, myGC,BlackPixel(display,screen));
			}
		}
		else {
			printf ("Kann Farbe %s nicht finden\n", colourname);
			printf ("Verwende stattdessen Schwarz\n");
			XSetForeground(display, myGC, BlackPixel(display, screen));
		}
	}
	else {
		printf("Keine Farbe in in dieser Tiefe:%d ?!\n", myDepth);
		printf ("Verwende stattdessen Schwarz \n");
		XSetForeground (display, myGC, BlackPixel(display, screen));
	}
}

//**********************************************************************
draw_clock(Display *display, int screen, Window win, GC mygc, int width, int height)
{
	int i;
	int dx = width;
	int dy = height/5;
	int BORDER = dx*17/1000; 

	// aktuelle Uhrzeit
	now = time (NULL);
	now_tm	= localtime (&now);
    now_s	= now_tm->tm_sec;
	now_m	= now_tm->tm_min;
	now_h	= now_tm->tm_hour;
	
	// Sekundenanzeige
	if(now_s % 2) setcolourvianame (display, screen, mygc, "gray8"); else setcolourvianame (display, screen, mygc, "yellow");
	XFillArc (display, win, mygc, \
	          width/2-(dy-2*BORDER)/2, 0+BORDER, 
	          dy-2*BORDER, \
	          dy-2*BORDER, \
	          0, 360*64);
	// Sekundenanzeige
	if(now_s % 2) setcolourvianame (display, screen, mygc, "gray8"); else setcolourvianame (display, screen, mygc, "yellow");
	XFillArc (display, win, mygc, \
	          width/2-(dy-2*BORDER)/2, 0+BORDER, 
	          dy-2*BORDER, \
	          dy-2*BORDER, \
	          0, 360*64);
	// Sonderlocke 00:00 Uhr...
	if ((now_h==0)&&(now_m==0)) now_h = 24;
	// 5er Stunden
	for (i=0; i<4; i++) {
		if (now_h/((i+1)*5)) setcolourvianame (display, screen, mygc, "red"); else setcolourvianame (display, screen, mygc, "gray8");
		XFillRectangle (display, win, mygc, \
		                dx/4*i+BORDER, \
		                1*dy+BORDER, \
		                dx/4-BORDER, \
		                dy-BORDER);
	}	
	// 1er Stunden
	for (i=0; i<4; i++) {
		if ((now_h%5)>i) setcolourvianame (display, screen, mygc, "red"); else setcolourvianame (display, screen, mygc, "gray8");
		XFillRectangle (display, win, mygc, \
		                dx/4*i+BORDER, \
		                2*dy+BORDER, \
		                dx/4-BORDER, \
		                dy-BORDER);
	}	
	// 5er Minuten
	for (i=0; i<11; i++) {
		if (now_m/((i+1)*5)) {
			// jedes dritte Zeichen in Rot...
			if ((i+1)%3) setcolourvianame (display, screen, mygc, "yellow"); else setcolourvianame (display, screen, mygc, "red");
			 
		} else setcolourvianame (display, screen, mygc, "gray8");
		XFillRectangle (display, win, mygc, \
		                dx/11*i+BORDER, \
		                3*dy+BORDER, \
		                dx/11-BORDER, \
		                dy-BORDER);
	}
	// 1er Minuten
	for (i=0; i<4; i++) {
		if ((now_m%5)>i) setcolourvianame (display, screen, mygc, "yellow"); else setcolourvianame (display, screen, mygc, "gray8");
		XFillRectangle (display, win, mygc, \
		                dx/4*i+BORDER, \
		                4*dy+BORDER, \
		                dx/4-BORDER, \
		                dy-BORDER);
	}	
	XFlush (display);
}

//**********************************************************************
void sigh(int signal) {
	// im Sekundentakt wird ein Refresh-Ereignis an X gesendet...
	XClearArea(mydpy, mywin, 0, 0, 1, 1, True);
	XFlush(mydpy);
	alarm(1);
} 

//**********************************************************************
//**********************************************************************
//**********************************************************************
main(int argc, char *argv[])
{
	GC mygc;
	XEvent myevent;
	XSizeHints myhint;
	XWindowAttributes mywinattr;
	int myscreen;
	unsigned long fg, bg;
	unsigned int win_width, win_height;
	char text[10];

	// X-Fenster initialisieren
	if(!(mydpy = XOpenDisplay(NULL))) {
		(void)fprintf(stderr, "Unable to open display: %s\n",
		XDisplayString(NULL));
	exit(1);
	}
	myscreen = DefaultScreen(mydpy);
	fg = WhitePixel(mydpy, myscreen);
	bg = BlackPixel(mydpy, myscreen);
	myhint.x = WINDOW_WIDTH;
	myhint.y = WINDOW_HEIGHT;
	myhint.width = WINDOW_WIDTH;
	myhint.height = WINDOW_HEIGHT;
	myhint.flags = PPosition | PSize;
	mywin = XCreateSimpleWindow(mydpy,
			DefaultRootWindow(mydpy),
			myhint.x, myhint.y, myhint.width, myhint.height,
			5, fg, bg);
	XSetStandardProperties(mydpy, mywin, win_title, win_title,
			None, argv, argc, &myhint);
	mygc = XCreateGC(mydpy, mywin, 0, 0);
	XSetForeground(mydpy, mygc, fg);
	XSetBackground(mydpy, mygc, bg);
	XSelectInput(mydpy, mywin,
			ButtonPressMask | KeyPressMask | ExposureMask);
	XMapRaised(mydpy, mywin);
 	XFlush(mydpy);
	// Uhr das 1.Mal zeichnen
	draw_clock(mydpy, myscreen, mywin, mygc, myhint.width, myhint.height);
	// Sekundentimer initialisieren (fast so, wie bei MCs :-))
	signal(SIGALRM, sigh);
	alarm(1); 
	// Endlosloop
	while(1) {
		XNextEvent(mydpy, &myevent);
		switch(myevent.type) {
			case Expose:
					if(myevent.xexpose.count == 0){
						XGetWindowAttributes(mydpy, mywin, &mywinattr);
						win_width = mywinattr.width;
						win_height= mywinattr.height;
						draw_clock(mydpy, myscreen, mywin, mygc, win_width, win_height);
					}
					break;

			case MappingNotify:
					break;

			case ButtonPress:
					break;

			case KeyPress:
					draw_clock(mydpy, myscreen, mywin, mygc, win_width, win_height);
					break;
		}
	}
	// Programm kmmt zwar nie hier hin, aber der Ordnung halber...;-)
	XFreeGC(mydpy, mygc);
	XDestroyWindow(mydpy, mywin);
	XCloseDisplay(mydpy);
	exit(0);
}

